#**
#**
#**  File     :  /hook/lua/UserSync.lua
#**
#****************************************************************************

local modPath = 'ZeP_MurderParty_V05'

local baseOnSync = OnSync

function OnSync()
	baseOnSync()
	
	# Sim to UI
	if Sync.mAssignment then
		import('/mods/'..modPath..'/modules/murder.lua').SetAssignment(Sync.mAssignment)
	end
	if Sync.mStats then
		import('/mods/'..modPath..'/modules/murder.lua').SetMurderStats(Sync.mStats)
	end
	if Sync.mAlert then
		import('/mods/'..modPath..'/modules/murder.lua').ShowAlert(Sync.mAlert)
	end
	if Sync.mSkin then
		import('/mods/'..modPath..'/modules/murder.lua').SetLayout()
	end
	if Sync.mVote then
		import('/mods/'..modPath..'/modules/murder.lua').ShowBonusVote()
	end
end
