#Ze_PilOt <thepilot@easynet.be>
#murder party 1.0b5
#vote and UI stuffs from phantom N 1, credits to novaprim3

local originalBeginSession = BeginSession

local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local cur = {
murderList = nil,
	config = {
		vote = 15,
		declare = 40,
		bonus = 1
		
	},
	votes = {}
}


msgOut = function(text, army)
local color = nil;
if (army != nil) then
	local colorIndex = ScenarioInfo.ArmySetup[army].PlayerColor;
	color = import('/lua/GameColors.lua').GameColors.ArmyColors[colorIndex];
end
PrintText(text, 20, color, 10, 'center') ;
end


function BonusRessourceThread()

	while true do
		WaitSeconds(0.1)
		local mass = 0
		local energy = 0
		local bonus = 0
		coef_bonus = cur.config.bonus
		for index, army in ArmyBrains do
			
			local curArmy = army:GetArmyIndex()
			if ArmyIsOutOfGame(curArmy) == false then
			local brain = GetArmyBrain(curArmy)
			bonus =	brain:GetArmyStat("bonusPred",0.0).Value
			energy = brain:GetEconomyIncome('ENERGY')
			mass = brain:GetEconomyIncome('MASS')
			--bonus de 4 = 1 bon kill = 10% income donc 0.025
			-- bonus de 2 = 1 pred tue = 5% : 2*0.025 = 0.05% okay !
			
			bonus = bonus * (0.025 * coef_bonus)
			player_mass = mass * bonus -- le bonus = masse actuelle * le bonus
			player_energy = energy * bonus
				brain:GiveResource('MASS',  player_mass)
				brain:GiveResource('ENERGY', player_energy)
			end
					
		end
	
	end

end



getUsername = function(army)
return GetArmyBrain(army).Nickname;
end

function OnPopulate()
ScenarioUtils.InitializeArmies()
end


function tableRandomize(Table)
local RandTable = {}
local CopyTable = Table


-- While we still have stuff left


while (table.getn(CopyTable) > 0) do
	-- Get a random value
	local Rand = math.random(1, table.getn(CopyTable))

	-- Insert the random value to the new table
	table.insert(RandTable, CopyTable[Rand])

	-- Remove the key
	table.remove(CopyTable, Rand)

	-- Add one to the count (remove this if you want)

end

return RandTable
end




function checkDeadThread(army)

local curPlayerInfo = army:GetArmyIndex()
local var = GetArmyBrain(curPlayerInfo).Nickname


end



function getPrey(player)

local prey

	for index, army in cur.MurderList do
	
	
		
		local curPlayerInfo = army:GetArmyIndex()
		
			if curPlayerInfo == player then
				---- on check qui est la proie
				if index != table.getn(cur.MurderList) then
					prey =  next(cur.MurderList,index)
				end
				if index == table.getn(cur.MurderList) then
					prey =  next(cur.MurderList)
				end
			end
		
		end

return cur.MurderList[prey]:GetArmyIndex()
end


function getPredator(player)

local predator

	for index, army in cur.MurderList do

		local curPlayerInfo = army:GetArmyIndex()
		
			if curPlayerInfo == player then
				--- on check qui est le predator
				if index == 1 then
					predator = table.getn(cur.MurderList)
					break
				end
				if index != 1 then
					predator = index-1
					break
				end
			end
		
		end

return cur.MurderList[predator]:GetArmyIndex()
end

function givePreyThread(MurderPlayers)

for index, army in MurderPlayers do

	-- curPlayerInfo = players en cours dans l'index
	local curPlayerInfo = army:GetArmyIndex()
	local playerToKill = 0

	-- si on depasse pas le nombre de players dans l'index, on prend le suivant, no prob
	if index != table.getn(MurderPlayers) then
		playerToKill =  next(MurderPlayers,index)
	end
	-- si on sort de l'index, on prend le premier joueur de la liste
	if index == table.getn(MurderPlayers) then
		playerToKill =  next(MurderPlayers)
	end


	-- du coup, var2 = le pseudo du joueur suivant

	local playerToKillInfo = MurderPlayers[playerToKill]:GetArmyIndex()

	local var2 = GetArmyBrain(playerToKillInfo).Nickname
	local var = GetArmyBrain(curPlayerInfo).Nickname

	if curPlayerInfo == GetFocusArmy() then

		if var != var2 then 
			text = LOCF('Your mission is to kill %s', var2) 
			Sync.mAlert = { "You have got a new mission !", false }
			Sync.mStats = text
		end
	end

end

end


getCommanders = function(army)
local list = GetArmyBrain(army):GetListOfUnits(categories.COMMAND , false);
for i, u in list do
	if (u:IsDead() == false) then
		return u;
	end
end
end

function MPMainThread()
	cur.votes[1] = 0
	cur.votes[2] = 0
	cur.votes[3] = 0
	import('/lua/SimPlayerQuery.lua').AddQueryListener("BonusVote", vote)

Sync.mAlert = { "Welcome", "to the Murder Party" }
Sync.mSkin = true
Sync.mAssignment = "Searching your target ..."




local ArmyScore = {}

local Bonus_Resource_Thread = ForkThread(BonusRessourceThread)

for army, brain in ArmyBrains do
	brain:AddArmyStat("assasination",0)
	brain:AddArmyStat("bonusPred",0)

	brain.CalculateScore = MPCalculateScore
end

local MurderPlayers = {}
local MurderPlayers2 = {}

for index, army in ArmyBrains do
	if ArmyIsCivilian(index) == false and ArmyIsOutOfGame(index) == false then
		table.insert(MurderPlayers, army)



	end
end
cur.MurderList = tableRandomize(MurderPlayers)

--on insere un trigger sur les commandeurs
--WaitSeconds(40)

	WaitSeconds(cur.config.vote)
	Sync.mVote = true
	WaitSeconds(cur.config.declare - cur.config.vote)
	
	local voteMax = 0
	local voteIndex = 0
	for key, val in cur.votes do
		if val > voteMax then
			voteMax = val
			voteIndex = key
		end
	end
	
		if voteIndex > 0 then
		cur.config.bonus = voteIndex
		end


local give_Prey_thread = ForkThread(givePreyThread, cur.MurderList)


Sync.mAssignment = "Mission in progress"
WaitSeconds(10)
	if  cur.config.bonus == 1 then
		Sync.mAlert = { "The bonus will be 10 percent", false}
	end

	if  cur.config.bonus == 2 then
		Sync.mAlert = { "The bonus will be 20 percent", false}
	end
	

	if  cur.config.bonus == 3 then
		Sync.mAlert = { "The bonus will be 30 percent", false}
	end
WaitSeconds(10)	
	Sync.mAlert = { "ALERT !", "Someone want to kill you too.."}
	



for index, army in cur.MurderList do

	local commanderList = getCommanders(index)
	
	commanderList.OldOnKilled = commanderList.OnKilled;
	commanderList.OnKilled = function(self, instigator, type, overkillRatio)

	myArmy = self:GetArmy() 

	if instigator then

	local prey = getPrey(myArmy)
	local preyNickname = GetArmyBrain(prey).Nickname
	LOG('the prey was ',preyNickname)
	
	local predator = getPredator(myArmy)
	local predNickname = GetArmyBrain(predator).Nickname
	LOG('the predator was ',predNickname)
	
	
	if instigator and instigator:GetArmy() == predator then
		-- le tu etait le predator, il gagne !
			local brain = ArmyBrains[instigator:GetArmy()]
			brain:AddArmyStat("assasination",1)
			brain:AddArmyStat("bonusPred",4)
	end

	if instigator and instigator:GetArmy() == prey then
		-- le tu etait la proie, il gagne un bonus
			local brain = ArmyBrains[instigator:GetArmy()]
			brain:AddArmyStat("bonusPred",2)
	end

	if instigator and instigator:GetArmy() != prey and instigator:GetArmy() != predator and instigator:GetArmy() != myArmy  then
		-- n'importe quel autre tueur
			local brain = ArmyBrains[instigator:GetArmy()]
			brain:AddArmyStat("assasination",-1)
			brain:AddArmyStat("bonusPred",-4)
	end

	if instigator and instigator:GetArmy()== myArmy then
		local preyBrain = GetArmyBrain(prey)
		local predBrain = GetArmyBrain(predator)
		predBrain:AddArmyStat("bonusPred",3)
		predBrain:AddArmyStat("assasination",1)
		preyBrain:AddArmyStat("bonusPred",1)
		
	end

end
	if not instigator or instigator:GetArmy()== myArmy then
			
			LOG('Suicide/deco!') 
			
			
	end

	self.OldOnKilled(self, instigator, type, overkillRatio);

end

end



local end_game = false
local old_players_alive = -1


while end_game == false do

	WaitSeconds(0.1)
	--- begin loop
	local oldPlayerList = cur.MurderList
	local deadGuy = -1
	for index, army in oldPlayerList do
		local curPlayer = army:GetArmyIndex()
		-- check for dead guy in the list
		if	ArmyIsCivilian(curPlayer) == false and ArmyIsOutOfGame(curPlayer) == true then
			local check_Dead_Thread = ForkThread(checkDeadThread,army)
			-- and we remove it from the list of players
			table.remove(cur.MurderList, index)
			
			deadGuy = 1
			-- end if
		end

		---end for
	end


	if deadGuy == 1 then
		cur.MurderList = tableRandomize(cur.MurderList)
		local give_Prey_thread = ForkThread(givePreyThread, cur.MurderList)
	end

	--- end loop



end


end

function OnStart()
local MP_main_thread = ForkThread(MPMainThread)

end


function BeginSession()
LOG('beginning sim')
originalBeginSession()
LOG('Begin the hunt')
OnStart()

end


function MPCalculateScore(self)
local success = self:GetArmyStat("assasination",0.0).Value
return math.floor(success)
end

function vote(data)
	cur.votes[data.Args.Vote] = cur.votes[data.Args.Vote] + 1
	if data.Args.Vote == 1 then
		print(data.Args.Nick.." voted for 10 percent bonus")
	end
	if data.Args.Vote == 2 then
		print(data.Args.Nick.." voted for 20 percent bonus")
	end
		if data.Args.Vote == 3 then
		print(data.Args.Nick.." voted for 30 percent bonus")
	end
end