#****************************************************************************
#**
#**  File     :  /hook/lua/ui/game/gamemain.lua
#**  Author(s):  novaprim3
#**
#**  Summary  :  Multi-Phantom Mod for Forged Alliance
#**
#****************************************************************************
local modPath = 'ZeP_MurderParty_V05'

local baseCreateUI = CreateUI 

function CreateUI(isReplay) 
	baseCreateUI(isReplay) 
	
  	if not isReplay then
		local parent = import('/lua/ui/game/borders.lua').GetMapGroup()
		import('/mods/'..modPath..'/modules/murder.lua').CreateModUI(isReplay, parent)
	end
end
